/*
 * rubrica.cpp
 *
 *  Created on: 13/mag/2013
 *      Author: bertini
 */

#include "Persona.h"
#include <map>
#include <iostream>

using namespace std;

int main() {
	Persona p1;
	p1.nome = "Pinco";
	p1.cognome = "Pallino";

	Persona p2;
	p2.nome = "Tizio";
	p2.cognome = "Caio";

	multimap<string, Persona> rubrica;
	rubrica.insert(pair<string, Persona>(p1.cognome, p1));
	rubrica.insert(pair<string, Persona>(p2.cognome, p2));

	multimap<string, Persona>::iterator it;
	for (it = rubrica.begin(); it != rubrica.end(); it++) {
		cout << (*it).second.cognome << endl;
	}

	multimap<string, Persona>::iterator trovato;
	trovato = rubrica.find("Pallino"); // e' un metodo non una funzione come l'algoritmo find di STL !
	// Conosce come e' fatta la multimap e sfrutta la sua struttura dati per andare O(log(n)) !
	// L'algoritmo find sarebbe lento: O(n) dato che accede con gli iteratori, quindi ignorando l'implementazione interna
	if (trovato != rubrica.end())
		cout << (*trovato).second.nome << endl;
	else
		cout << "Non trovato" << endl;
}

